

uniform mat4 u_proj;
uniform mat4 u_modelview;
uniform mat4 u_modelview_scene;
uniform mat3 u_normal_matrix;

uniform vec4 u_light_pos;


attribute vec2 a_uv;
attribute vec4 a_pos;
attribute vec3 a_norm;
attribute vec3 a_tangent;

varying mat3 v_inv_tbn;

varying vec3 v_pos;
varying vec2 v_uv;

varying vec4 v_light_pos;



void main() {

	v_pos = vec3( u_modelview * vec4(a_pos) );
	v_uv = a_uv;

	v_light_pos = u_modelview_scene * u_light_pos;

	vec3 t = u_normal_matrix * a_tangent;
    vec3 n = u_normal_matrix * a_norm;
	vec3 b = normalize(cross(t, n));  // t, n ?
	
	
	
	//v_inv_tbn = inverse( transpose(mat3(t,b,n)) ); 
	v_inv_tbn = ( mat3(t,b,n) ); // wrong, only for test 110
	
	gl_Position = u_proj * u_modelview * a_pos;
	

}
