#ifdef GL_ES
	precision mediump float;
#endif

varying vec2 v_uv;
varying vec3 v_pos; 

uniform sampler2D u_sampler;
uniform sampler2D u_sampler_tcs;
uniform sampler2D u_sampler_blur;

uniform mat4 u_color_matrix;

uniform float u_aspect;
uniform float u_blur_scale;


void main() {


	vec4 tcs = texture2D(u_sampler_tcs, v_uv);
    vec2 tcs_shift = 0.3*(0.001*floor(0.5+1000.0*tcs.rg) - vec2(0.5));
    
    
    
    vec4 c_blur = texture2D(u_sampler_blur, v_uv);
    
    float blur_base = u_blur_scale; 
    
    float blur_offset = blur_base * c_blur.r; // , blur_base * c_blur.r * u_aspect );
		
	vec2 uv0 = v_uv + vec2(-3.0*blur_offset,  0.0) + tcs_shift;
	vec2 uv1 = v_uv + vec2(-2.0*blur_offset,  0.0) + tcs_shift;
	vec2 uv2 = v_uv + vec2(-1.0*blur_offset,  0.0) + tcs_shift;
	vec2 uv3 = v_uv + vec2( 0.0,              0.0) + tcs_shift;
	vec2 uv4 = v_uv + vec2( 1.0*blur_offset,  0.0) + tcs_shift;
	vec2 uv5 = v_uv + vec2( 2.0*blur_offset,  0.0) + tcs_shift;
	vec2 uv6 = v_uv + vec2( 3.0*blur_offset,  0.0) + tcs_shift;
	 
	vec4 c0 = texture2D(u_sampler, uv0);
	vec4 c1 = texture2D(u_sampler, uv1);
	vec4 c2 = texture2D(u_sampler, uv2);
	vec4 c3 = texture2D(u_sampler, uv3);
	vec4 c4 = texture2D(u_sampler, uv4);
	vec4 c5 = texture2D(u_sampler, uv5);
	vec4 c6 = texture2D(u_sampler, uv6);
	 
	vec4 sum = ( 1.0*c0 + 2.0*c1 + 4.0*c2 + 8.0*c3 + 4.0*c4 + 2.0*c5 + 1.0*c6 ) / 22.0;
    sum = u_color_matrix * sum * tcs.b * 2.0;
	
    gl_FragColor = vec4(vec3(sum), 1.0);

}

