#ifdef GL_ES
	precision mediump float;
#endif

varying vec2 v_uv;
varying vec3 v_pos; 

uniform sampler2D u_sampler;
uniform sampler2D u_sampler_tcs;

uniform mat4 u_color_matrix;


uniform float u_time;

#define M_PI 3.141592654

void main() {

    vec4 c;
    
	vec4 tcs = texture2D(u_sampler_tcs, v_uv);
    //tcs.rg = 0.01*floor(0.5+100.0*tcs.rg) - vec2(0.5);
    
    tcs.rg = tcs.rg - vec2(0.5);
    tcs.rg = clamp(tcs.rg, 0.01, 1.0) + clamp(tcs.rg, -1.0, -0.01); // make zero true zero
    
    
    c = texture2D(u_sampler, v_uv + 0.3*tcs.rg) * tcs.b * 2.0; 
    
    
    c = u_color_matrix * c;
    
    
    gl_FragColor = vec4(vec3(c), 1.0);
    

}

