uniform mat4 u_proj;
uniform mat4 u_modelview;
uniform mat4 u_modelview_scene;
uniform mat3 u_normal_matrix;

uniform vec4 u_light_pos;


attribute vec2 a_uv;
attribute vec4 a_pos;
attribute vec3 a_norm;


varying vec2 v_uv;
varying vec3 v_norm;
varying vec3 v_pos;

varying vec3 v_light_pos;


void main() {

	v_uv = a_uv; 
    v_norm = u_normal_matrix * a_norm;
	v_pos = vec3( u_modelview * vec4(a_pos) );
	
	v_light_pos = vec3(u_modelview_scene * u_light_pos);
	
	gl_Position = u_proj * u_modelview * a_pos;
	
}
